import re
import sys
import uuid
import math
import hashlib
import datetime
from io import BytesIO

def __VarintDecode(stream):
    if stream == b'':
        return
    data = BytesIO(stream)
    qwe = 0
    result = 0
    shift = 0
    last_shift = 0
    while True:
        if qwe > 5:
            return

        c = data.read(1)
        i = ord(c)
        last_shift += len(c)
        result |= (i & 0x7f) << shift
        shift += 7
        qwe += 1
        if not (i & 0x80):
            break

    return result, last_shift

def __VarintEncode(number):
    result = b''
    while True:
        towrite = number & 0x7f
        number >>= 7
        if number:
            result += bytes(((towrite | 0x80),))
        else:
            result += bytes((towrite,))
            break
    return result

def __packSize(format,fmtIndex,mass,p):
    for x in range(0, len(format)):
        if format[x] == '!':
            pass

        elif format[x] == 'i':
            if type(mass[x]) != int:
                raise Exception(
                    f'Invalid variable format, format type: int, variable type: {type(mass[x])}')

        elif format[x] == 's':
            if type(mass[x]) != str:
                raise Exception(
                    f'Invalid variable format, format type: str, variable type: {type(mass[x])}')

        elif format[x] == 'p':
            if type(mass[x]) != str:
                raise Exception(
                    f'Invalid variable format, format type: str, variable type: {type(mass[x])}')

            if p != 'sha3_512' and p != 'sha3_384' and p != 'sha3_256' and p != 'sha3_224' and p != 'sha224' and p != 'sha256' and p != 'sha384' and p != 'sha512' and p != 'shake_128' and p != 'shake_256' and p != 'blake2s' and p != 'blake2b' and p != 'md5' and p != 'sha1':
                raise Exception('Invalid value for encryption')

        elif format[x] == 'B':
            if type(mass[x]) != bool:
                raise Exception(
                    f'Invalid variable format, format type: bool, variable type: {type(mass[x])}')

        elif format[x] == 'u':
            if type(mass[x]) != uuid.UUID:
                raise Exception(
                    f'Invalid variable format, format type: uuid, variable type: {type(mass[x])}')

        elif format[x] == 'c':
            if type(mass[x]) != str and len(mass[x]) != 1:
                raise Exception(
                    f'Invalid variable format, format type: chr, variable type: {type(mass[x])}')

        elif format[x] == 'b':
            if type(mass[x]) != bytes:
                raise Exception(
                    f'Invalid variable format, format type: bytes, variable type: {type(mass[x])}')

        elif format[x] == 'f':
            if type(mass[x]) != float:
                raise Exception(
                    f'Invalid variable format, format type: float, variable type: {type(mass[x])}')

        elif format[x] == 'd':
            if type(mass[x]) != datetime.datetime:
                raise Exception(
                    f'Invalid variable format, format type: datetime, variable type: {type(mass[x])}')

        elif format[x] == 't':
            if type(mass[x]) != float:
                raise Exception(
                    f'Invalid variable format, format type: float, variable type: {type(mass[x])}')

        else:
            raise Exception('Invalid variable type')

    resultMass = []
    for x in range(0, len(format)):
        if format[x] == '!':
            pass

        elif format[x] == 'i':
            res = __VarintEncode(mass[x])
            resultMass.append(res)

        elif format[x] == 's':
            var1 = mass[x].encode('UTF-8')
            var2 = __VarintEncode(len(var1))
            res = var2 + var1
            resultMass.append(res)

        elif format[x] == 'p':
            if p == 'sha3_512':
                var1 = Encryption.sha3_512(mass[x])
            elif p == 'sha3_384':
                var1 = Encryption.sha3_384(mass[x])
            elif p == 'sha3_256':
                var1 = Encryption.sha3_256(mass[x])
            elif p == 'sha3_224':
                var1 = Encryption.sha3_224(mass[x])
            elif p == 'sha224':
                var1 = Encryption.sha224(mass[x])
            elif p == 'sha256':
                var1 = Encryption.sha256(mass[x])
            elif p == 'sha384':
                var1 = Encryption.sha384(mass[x])
            elif p == 'sha512':
                var1 = Encryption.sha512(mass[x])
            elif p == 'shake_128':
                var1 = Encryption.shake_128(mass[x])
            elif p == 'shake_256':
                var1 = Encryption.shake_256(mass[x])
            elif p == 'blake2s':
                var1 = Encryption.blake2s(mass[x])
            elif p == 'blake2b':
                var1 = Encryption.blake2b(mass[x])
            elif p == 'md5':
                var1 = Encryption.md5(mass[x])
            else:
                raise Exception('Invalid value for encryption')

            var2 = __VarintEncode(len(var1))
            res = var2 + var1
            resultMass.append(res)

        elif format[x] == 'B':
            res = __VarintEncode(mass[x])
            resultMass.append(res)

        elif format[x] == 'u':
            res = mass[x].bytes
            resultMass.append(res)

        elif format[x] == 'c':
            res = __VarintEncode(ord(mass[x]))
            resultMass.append(res)

        elif format[x] == 'b':
            var1 = mass[x]
            var2 = __VarintEncode(len(var1))
            res = var2 + var1
            resultMass.append(res)

        elif format[x] == 'f':
            res = __VarintEncode(int(mass[x] * (10 ** 10)))
            resultMass.append(res)

        elif format[x] == 'F':
            var1 = str(mass[x]).encode('UTF-8')
            var2 = __VarintEncode(len(var1))
            res = var2 + var1
            resultMass.append(res)

        elif format[x] == 'd':
            var1 = int(mass[x].timestamp())
            res = __VarintEncode(var1)
            resultMass.append(res)

        elif format[x] == 't':
            res = __VarintEncode(int(mass[x] * (10 ** 10)))
            resultMass.append(res)

    fmt = format.encode('UTF-8')
    fmtLen = __VarintEncode(len(fmt))
    resultSize = fmtLen+fmt

    for xx in resultMass:
        resultSize+=xx
    size = sys.getsizeof(resultSize)
    N = math.log2(size)+1
    size += (N/8+1)
    size = __VarintEncode(int(size))
    resultMass.insert(fmtIndex, size)

    result = b''
    for xxx in resultMass:
        result += xxx

    return fmtLen + fmt + result

def pack(format, *args,p='md5'):
    characherRegex = re.compile(r'[!ispBucbfFdt]*$')

    if '!' in format:
        if len(format) == 1 and len(args) == 0:
            raise Exception('Not enough arguments')
        else:
            if len(format) != len(args)+1:
                raise Exception('The package format does not match the number of variables entered')
            else:
                if characherRegex.match(format) == None:
                    raise Exception('Invalid characters in the format')
                else:
                    size = 0
                    fmtIndex = format.find('!')
                    mass = [*args]
                    mass.insert(fmtIndex,size)
                    return __packSize(format,fmtIndex,mass,p)

    else:
        if len(format) != len(args):
            raise Exception('The package format does not match the number of variables entered')
        else:
            if characherRegex.match(format) == None:
                raise Exception('Invalid characters in the format')
            else:
                for x in range(0, len(format)):
                    if format[x] == 'i':
                        if type(args[x]) != int:
                            raise Exception(f'Invalid variable format, format type: int, variable type: {type(args[x])}')

                    elif format[x] == 's':
                        if type(args[x]) != str:
                            raise Exception(f'Invalid variable format, format type: str, variable type: {type(args[x])}')

                    elif format[x] == 'p':
                        if type(args[x]) != str:
                            raise Exception(f'Invalid variable format, format type: str, variable type: {type(args[x])}')

                        if p != 'sha3_512' and p != 'sha3_384' and p != 'sha3_256' and p != 'sha3_224' and p != 'sha224' and p != 'sha256' and p != 'sha384' and p != 'sha512' and p != 'shake_128' and p != 'shake_256' and p != 'blake2s' and p != 'blake2b' and p != 'md5' and p != 'sha1':
                            raise Exception('Invalid value for encryption')

                    elif format[x] == 'B':
                        if type(args[x]) != bool:
                            raise Exception(f'Invalid variable format, format type: bool, variable type: {type(args[x])}')

                    elif format[x] == 'u':
                        if type(args[x]) != uuid.UUID:
                            raise Exception(f'Invalid variable format, format type: uuid, variable type: {type(args[x])}')

                    elif format[x] == 'c':
                        if type(args[x]) != str and len(args[x]) != 1:
                            raise Exception(f'Invalid variable format, format type: chr, variable type: {type(args[x])}')

                    elif format[x] == 'b':
                        if type(args[x]) != bytes:
                            raise Exception(f'Invalid variable format, format type: bytes, variable type: {type(args[x])}')

                    elif format[x] == 'F':
                        if type(args[x]) != float:
                            raise Exception(f'Invalid variable format, format type: int, variable type: {type(args[x])}')

                    elif format[x] == 'f':
                        if type(args[x]) != float:
                            raise Exception(f'Invalid variable format, format type: float, variable type: {type(args[x])}')

                    elif format[x] == 'd':
                        if type(args[x]) != datetime.datetime:
                            raise Exception(
                                f'Invalid variable format, format type: datetime, variable type: {type(args[x])}')

                    elif format[x] == 't':
                        if type(args[x]) != float:
                            raise Exception(f'Invalid variable format, format type: float, variable type: {type(args[x])}')

                    else:
                        raise Exception('Invalid variable type')

                result = b''
                for x in range(0, len(format)):
                    if format[x] == 'i':
                        res = __VarintEncode(args[x])
                        result += res

                    elif format[x] == 's':
                        var1 = args[x].encode('UTF-8')
                        var2 = __VarintEncode(len(var1))
                        res = var2 + var1
                        result += res

                    elif format[x] == 'p':
                        if p == 'sha3_512':
                            var1 = Encryption.sha3_512(args[x])
                        elif p == 'sha3_384':
                            var1 = Encryption.sha3_384(args[x])
                        elif p == 'sha3_256':
                            var1 = Encryption.sha3_256(args[x])
                        elif p == 'sha3_224':
                            var1 = Encryption.sha3_224(args[x])
                        elif p == 'sha224':
                            var1 = Encryption.sha224(args[x])
                        elif p == 'sha256':
                            var1 = Encryption.sha256(args[x])
                        elif p == 'sha384':
                            var1 = Encryption.sha384(args[x])
                        elif p == 'sha512':
                            var1 = Encryption.sha512(args[x])
                        elif p == 'shake_128':
                            var1 = Encryption.shake_128(args[x])
                        elif p == 'shake_256':
                            var1 = Encryption.shake_256(args[x])
                        elif p == 'blake2s':
                            var1 = Encryption.blake2s(args[x])
                        elif p == 'blake2b':
                            var1 = Encryption.blake2b(args[x])
                        elif p == 'md5':
                            var1 = Encryption.md5(args[x])
                        elif p == 'sha1':
                            var1 = Encryption.sha1(args[x])
                        else:
                            raise Exception('Invalid value for encryption')

                        var2 = __VarintEncode(len(var1))
                        res = var2 + var1
                        result += res

                    elif format[x] == 'B':
                        res = __VarintEncode(args[x])
                        result += res

                    elif format[x] == 'u':
                        res = args[x].bytes
                        result += res

                    elif format[x] == 'c':
                        res = __VarintEncode(ord(args[x]))
                        result += res

                    elif format[x] == 'b':
                        var1 = args[x]
                        var2 = __VarintEncode(len(var1))
                        res = var2 + var1
                        result += res

                    elif format[x] == 'f':
                        res = __VarintEncode(int(args[x]*(10*10)))
                        result += res

                    elif format[x] == 'F':
                        var1 = str(args[x]).encode('UTF-8')
                        var2 = __VarintEncode(len(var1))
                        res = var2 + var1
                        result += res

                    elif format[x] == 'd':
                        var1 = int(args[x].timestamp())
                        res = __VarintEncode(var1)
                        result += res

                    elif format[x] == 't':
                        res = __VarintEncode(int(args[x] * (10 ** 10)))
                        result += res

                fmt = format.encode('UTF-8')
                fmtLen = __VarintEncode(len(fmt))
                return fmtLen + fmt + result

def unpack(stream):
    mass = []
    resSize = 0
    formatLen = __VarintDecode(stream)
    format = stream[1:formatLen[0] + formatLen[1]].decode()
    shift = formatLen[0] + formatLen[1]

    for x in range(0, len(format)):
        if format[x] == '!':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            resSize = res

        elif format[x] == 'i':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            mass.append(res)

        elif format[x] == 's':
            lastShift, last = __VarintDecode(stream[shift:])
            shift += last
            res = stream[shift:lastShift + shift].decode()
            shift += lastShift
            mass.append(res)

        elif format[x] == 'p':
            lastShift, last = __VarintDecode(stream[shift:])
            shift += last
            res = stream[shift:lastShift + shift]
            shift += lastShift
            mass.append(res)

        elif format[x] == 'B':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            if res:
                mass.append(True)
            else:
                mass.append(False)

        elif format[x] == 'u':
            res = uuid.UUID(bytes_le=stream[shift:shift + 16])
            shift += 16
            mass.append(res)

        elif format[x] == 'c':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            res = chr(res)
            mass.append(res)

        elif format[x] == 'b':
            lastShift, last = __VarintDecode(stream[shift:])
            shift += last
            res = stream[shift:lastShift + shift]
            shift += lastShift
            mass.append(res)

        elif format[x] == 'F':
            lastShift, last = __VarintDecode(stream[shift:])
            shift += last
            res = stream[shift:lastShift + shift].decode()
            shift += lastShift
            mass.append(float(res))

        elif format[x] == 'f':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            mass.append(float(res/(10*10)))

        elif format[x] == 'd':
            var1, last = __VarintDecode(stream[shift:])
            shift += last
            res = datetime.datetime.fromtimestamp(var1)
            mass.append(res)

        elif format[x] == 't':
            res, last = __VarintDecode(stream[shift:])
            shift += last
            res = res / (10 ** 10)
            mass.append(res)

    if resSize != 0:
        result = {'format':format,'size':resSize,'items':mass}
    else:
        result = {'format':format,'items':mass}
    return result

def size(*args):
    return sys.getsizeof(*args)

def format(stream):
    try:
        format = unpack(stream)
        return format['format']
    except:
        raise Exception('Error finding the format')

def items(stream):
    try:
        res = unpack(stream)
        return res['items']
    except:
        raise Exception('Error finding the items')

class Encryption:
    @staticmethod
    def sha3_512(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha3_512(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha3_384(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha3_384(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha3_256(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha3_256(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha3_224(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha3_224(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha1(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha1(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha224(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha224(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha256(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha256(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha384(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha384(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def sha512(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.sha512(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def shake_128(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.shake_128(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def shake_256(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.shake_256(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def blake2s(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.blake2s(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def blake2b(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.blake2b(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

    @staticmethod
    def md5(data):
        if isinstance(data, str):
            data = data.encode('UTF-8')

        if isinstance(data, bytes):
            return (hashlib.md5(data).digest())
        else:
            raise Exception('Invalid data type. you can send either string or string bytes')

class decode:
    @staticmethod
    def varint(number):
        if number == b'':
            return
        data = BytesIO(number)
        qwe = 0
        result = 0
        shift = 0
        last_shift = 0
        while True:
            if qwe > 5:
                return

            c = data.read(1)
            i = ord(c)
            last_shift += len(c)
            result |= (i & 0x7f) << shift
            shift += 7
            qwe += 1
            if not (i & 0x80):
                break
        return result

class encode:
    @staticmethod
    def varint(number):
        result = b''
        while True:
            towrite = number & 0x7f
            number >>= 7
            if number:
                result += bytes(((towrite | 0x80),))
            else:
                result += bytes((towrite,))
                break
        return result
